#ifndef FORM_H
#define FORM_H

#include <vector>
#include <iostream>
#include <sstream>


enum Category {CIRCLE, SQUARE, RECTANGLE};

class Form;         // prédéclaration de la classe Form
typedef Form Bbox;  // le type Bbox est synonyme de Form

class Form
{
public:
    Form(Category c=CIRCLE, double x=0, double y=0, double p1=0); 
    Form(Category c, double x, double y, double p1, double p2 ); 

    void affiche() ; 
    Category get_category() ;
    std::vector<double> get_param() ;
    double get_x() ;
    double get_y() ;
    Form get_bbox() ;
    Bbox merge_bbox(Bbox& other);
    bool intersect_bbox(Bbox& other);
private:
    Category category;
    double x,y;
    std::vector<double> param{std::vector<double>(1,0.)};
};

std::ostream & operator<<(std::ostream & o, Form & f);

Form form_lecture(std::istringstream& data, Category c);

#endif
